require "utils"
require "creatures"
require "jobs"
require "tiles"
require "map1"
require "players"
require "items"

lg = love.graphics

handstore = {}

gameticker = 0
tickinterval = 0.1
scale = 16

creaturelist={}

rooms={
	den={},
	bank={},
	heart={},
	portal={},
}

roomlist={}

joblist={}

tilestore={{}}

itemstore={{}}

function love.load()

	for y,v in pairs(tilemap) do
		
		tilestore[y]={}
		itemstore[y] = {}
		for x,t in pairs(v) do
			
			sx = x*(scale+4);
			sy = y*(scale+4);
			tile = deepcopy(search(tiles,t))
			tile.x = sx
			tile.gx = x
			tile.y = sy
			tile.gy = y
			tilestore[y][x]=tile			
		end
	end

	for y,v in pairs(creaturemap) do

                creaturelist[y]={}

                for x,t in pairs(v) do
                        sx = x*(scale+4)+scale/2;
                        sy = y*(scale+4)+scale/2;
                        creature = deepcopy(search(creatures,t))
                        creature.uniqueid="p1"..creature.name..x..y
						creature.x = sx
						creature.gx = x
                        creature.y = sy
						creature.gy = y
                        creaturelist[y][x]=creature
                end
        end
        
        for y,v in pairs(p2creaturemap) do
				creaturelist[y]=creaturelist[y] or {}
                for x,t in pairs(v) do
                        sx = x*(scale+4)+scale/2;
                        sy = y*(scale+4)+scale/2;
                        creature = deepcopy(search(creatures,t))
                        creature.uniqueid="p2"..creature.name..x..y
						creature.player = 2
						creature.x = sx
						creature.gx = x
                        creature.y = sy
						creature.gy = y
                        creaturelist[y][x]=creature
                end
        end

end

function love.keypressed(key)
	if key=="r" then

	for i,v in pairs(joblist) do
		print(v.id)
	end

	end
end

function love.mousepressed(x,y,button)

        --select creatures
        for sy,v in pairs(creaturelist) do
                for sx,t in pairs(v) do
                        if(fuzzyselect({x=t.x,y=t.y},{x=x,y=y},5)) then
				t.picked=true
				if(t.currentjob and t.currentjob.worker) then t.currentjob.worker=nil end
				t.currentjob=nil
				print(t.uniqueid)
				table.insert(handstore,t)
				return
			end
                end
        end
        
                --select items
        for sy,v in pairs(itemstore) do
                for sx,t in pairs(v) do
                        if(fuzzyselect({x=t.x,y=t.y},{x=x,y=y},5)) then
				if(handstore[1] and handstore[1].id==t.id and t.pilable) then 
					handstore[1].amount = handstore[1].amount+t.amount
					itemstore[t.gy][t.gx] = nil 
					return
				end
				
				t.picked=true
				if(t.currentjob and t.currentjob.worker) then t.currentjob.worker=nil end
				t.currentjob=nil
				print(t.uniqueid)
				table.insert(handstore,t)
				return
			end
                end
        end

	--select tiles
        for sy,v in pairs(tilestore) do
                for sx,t in pairs(v) do
                       if(fuzzyselect({x=t.x+scale/2,y=t.y+scale/2},{x=x,y=y},5)) then
				if(t.walkable and handstore[1]) then
					dropped = handstore[1]
					dropped.picked = false
					dropped.x = t.x+scale/2
					dropped.gx = t.gx
					dropped.y = t.y+scale/2
					dropped.gy = t.gy
					if (dropped.type=="creature") then refreshstore(dropped,creaturelist) end
					if (dropped.type=="item")then refreshstore(dropped,itemstore) end
					table.remove(handstore,1)
					return	
				elseif(t.currentjob) then
					table.remove(joblist,t.currentjob.jobid)
					t.currentjob = nil
					joblistrefresh()
				else
					for i,j in pairs(t.jobs) do
						job = deepcopy(search(jobs,j))
						job.target=t
						job.x = t.x
						job.gx = t.gx
						job.y = t.y
						job.gy = t.gy
						job.jobid = #joblist+1
						t.currentjob=job
						table.insert(joblist,job)
					end
				end
			end 
                end
        end

end

function love.update(dt)
	
	gameticker = gameticker + dt
	for i,v in pairs(handstore) do
		v.x = love.mouse.getX() + (i*scale/2)
		v.y = love.mouse.getY() + (i*scale/2)
	end
	--passive job lister
	for y,v in pairs(tilestore) do
		for x,t in pairs(v) do
			if(t.currentjob == nil) then
				for i,j in pairs(t.jobs) do
					job = deepcopy(search(jobs,j))
					if(job.passive) then
						job.target =t
                                                job.x = t.x
						job.gx = t.gx
                                                job.y = t.y
						job.gy = t.gy
                                                job.jobid = #joblist+1
                                                t.currentjob=job
						table.insert(joblist,job)
					end
				end
			end
		end
	end
	--creature job assignment and performance
	for y1,v1 in pairs(creaturelist) do


		for y,v in pairs(v1) do
                if(gameticker>tickinterval) then
		--	print("tick")
                       if(v.currentjob)then 
				if(fuzzyselect({x=v.currentjob.gx,y=v.currentjob.gy},{x=v.gx,y=v.gy},v.currentjob.range)) then
					v.currentjob.action(v.currentjob)
				else
				canreach=false
					--if(v.x+scale/2 ~= v.currentjob.x) then 
						if (v.gx < v.currentjob.gx) then 
								if(tilestore[v.gy][v.gx+1].walkable) then
									v.x = v.x + scale + scale/4
									v.gx = v.gx +1
								else
									v.pathingfails=v.pathingfails+1
								end
						elseif(tilestore[v.gy][v.gx-1] and tilestore[v.gy][v.gx-1].walkable) then 
							v.x = v.x - scale - scale/4
							v.gx = v.gx -1
						else v.pathingfails=v.pathingfails+1
						end --end
					if(v.gy ~= v.currentjob.gy) then 
						if (v.gy < v.currentjob.gy) then
							if(tilestore[v.gy+1][v.gx].walkable) then
								v.y = v.y + scale + scale/4
								v.gy = v.gy + 1
							 else
								v.pathingfails=v.pathingfails+1
							 end
						elseif(tilestore[v.gy-1][v.gx].walkable) then 
							v.y = v.y - scale - scale/4
							v.gy = v.gy -1 
						else v.pathingfails=v.pathingfails+1
						end end
				if(v.pathingfails>4)then 
					v.pathingfails = 0
					v.currentjob.worker = nil
					v.currentjob.target.currentjob = nil
					table.remove(joblist,v.currentjob.jobid)
					joblistrefresh()
					v.currentjob = nil 
				end

				end
			end
                end

			--for y2,v2 in pairs(v) do print(y2,v2) end
			if (v.currentjob == nil) then
				--print(v.uniqueid.." has no job")
				for i,j in pairs(v.jobs) do
					for ti, tj in pairs(joblist) do
						--if(tj.worker==nil) then print(tj.id.. " has no worker") end
						if( v.currentjob==nil and j==tj.id and tj.worker==nil and v.picked~=true and prepath(v,tj)) then
							v.currentjob=tj
							--v.x = tj.x+scale/2
							--v.y = tj.y+scale/2
							if(tj.worker)then tj.worker.currentjob=nil end
							tj.worker = v
						end
					end
				end
			end
		end
		--for i=1,j
		--gridsearch({x=v.gx,y=v.gy},tilestore,10,function(found) if(found=) then  end  end)
	end

	--refresh creaturestore
	
	for y,v in ipairs(creaturelist) do
		for x,c in ipairs(v) do
					if(c.currentjob) then refreshstore(c,creaturelist) end
		end
	end
	
	if(gameticker>tickinterval) then gameticker = 0 end
end

function love.draw(dt)
	
	--draw tiles
	for y,v in pairs(tilestore) do
		for x,t in pairs(v) do
			t.draw(t)
		end
	end

	--draw creatures
        for y,v in pairs(creaturelist) do
                for x,t in pairs(v) do
                        t.draw(t)
                end
        end

        --draw jobs
    for y,t in pairs(joblist) do
                
		t.draw(t)
                
    end
    
	for y,v in pairs(itemstore) do
		for x,t in pairs(v) do
			t.draw(t)
		end
	end

	for y,v in pairs(handstore) do
		--for i,details in pairs(v) do
			lg.print(v.name,400,400+y*10)
		--end
	end

end

function prepath(creature,job)
	v={currentjob={}}
	v.pathingfails=0
	v.gx = creature.gx
	v.x = creature.x
	v.y = creature.y
	v.gy = creature.gy
	
	v.currentjob.gx = job.gx
	v.currentjob.gy = job.gy
	v.currentjob.y = job.y
	v.currentjob.x = job.x
	v.currentjob.range = job.range
	while(v.pathingfails<5) do
				if(fuzzyselect({x=v.currentjob.gx,y=v.currentjob.gy},{x=v.gx,y=v.gy},v.currentjob.range)) then
					return true
				else
				canreach=false
					--if(v.x+scale/2 ~= v.currentjob.x) then 
						if (v.gx < v.currentjob.gx) then 
								if(tilestore[v.gy][v.gx+1].walkable) then
									v.x = v.x + scale + scale/4
									v.gx = v.gx +1
								else
									v.pathingfails=v.pathingfails+1
								end
						elseif(tilestore[v.gy][v.gx-1] and tilestore[v.gy][v.gx-1].walkable) then 
							v.x = v.x - scale - scale/4
							v.gx = v.gx -1
						else v.pathingfails=v.pathingfails+1
						end --end
					if(v.gy ~= v.currentjob.gy) then 
						if (v.gy < v.currentjob.gy) then
							if(tilestore[v.gy+1][v.gx].walkable) then
								v.y = v.y + scale + scale/4
								v.gy = v.gy + 1
							 else
								v.pathingfails=v.pathingfails+1
							 end
						elseif(tilestore[v.gy-1][v.gx].walkable) then 
							v.y = v.y - scale - scale/4
							v.gy = v.gy -1 
						else v.pathingfails=v.pathingfails+1
						end end
				if(v.pathingfails>4)then 
					return false
				end
			end
	end
end

function joblistrefresh()

	for i,v in pairs(joblist) do
		v.jobid=i
	end

end


